import { DefaultConfig } from "./config/default-config";
import { PatternConfig } from "./config/pattern-config";
import { CompareConfig } from "./config/compare-config";
import { AlphaConfig } from "./config/alpha-config";
import { RangeConfig } from "./config/range-config";
import { NumberConfig } from "./config/number-config";
import { MaxDateConfig } from "./config/max-date-config";
import { MinDateConfig } from "./config/min-date-config";
import { DigitConfig } from "./config/digit-config";
import { EmailConfig } from "./config/email-config";
import { MessageConfig } from "./config/message-config";
import { ArrayConfig } from "./config/array-config";
import { ChoiceConfig } from "./config/choice-config";
import { CreditCardConfig } from "./config/credit-card-config";
import { DifferentConfig } from "./config/compare-config";
import { BaseConfig } from "./config/base-config";
import { FactorConfig } from "./config/factor-config";
import { RelationalOperatorConfig } from "./config/relational-operator-config";
import { HexColorConfig } from "./config/hex-color-config";
import { NumericConfig } from "./config/numeric-config";
import { PasswordConfig } from "./config/password-config";
import { TimeConfig } from "./config/time-config";
import { ExtensionConfig } from "./config/extension-config";
import { SizeConfig } from "./config/size-config";
import { ValidatorFn, AsyncValidatorFn } from "@angular/forms";
export interface PropValidationConfig {
    allOf?: ArrayConfig;
    choice?: ChoiceConfig;
    required?: BaseConfig | boolean;
    creditCard?: CreditCardConfig;
    different?: DifferentConfig;
    even?: BaseConfig | boolean;
    factor?: FactorConfig;
    greaterThanEqualTo?: RelationalOperatorConfig;
    greaterThan?: RelationalOperatorConfig;
    hexColor?: HexColorConfig | boolean;
    json?: DefaultConfig;
    leapYear?: BaseConfig | boolean;
    lessThanEqualTo?: RelationalOperatorConfig;
    lessThan?: RelationalOperatorConfig;
    mac?: BaseConfig | boolean;
    noneOf?: ArrayConfig;
    numeric?: NumericConfig | boolean;
    odd?: BaseConfig | boolean;
    oneOf?: ArrayConfig;
    password?: PasswordConfig;
    time?: TimeConfig | boolean;
    url?: DefaultConfig | boolean;
    minLength?: NumberConfig;
    maxLength?: NumberConfig;
    pattern?: PatternConfig;
    compare?: CompareConfig;
    contains?: DefaultConfig;
    alpha?: AlphaConfig | boolean;
    digit?: DigitConfig | boolean;
    alphaNumeric?: AlphaConfig | boolean;
    email?: EmailConfig | boolean;
    lowerCase?: MessageConfig | boolean;
    maxDate?: MaxDateConfig;
    maxNumber?: NumberConfig;
    minDate?: MinDateConfig;
    minNumber?: NumberConfig;
    upperCase?: MessageConfig | boolean;
    range?: RangeConfig;
    custom?: ValidatorFn;
    ascii?: BaseConfig | boolean;
    dataUri?: BaseConfig | boolean;
    port?: BaseConfig | boolean;
    latLong?: BaseConfig | boolean;
    extension?: ExtensionConfig;
    fileSize?: SizeConfig;
    endsWith?: DefaultConfig;
    startsWith?: DefaultConfig | boolean;
    primeNumber?: BaseConfig | boolean;
    latitude?: BaseConfig | boolean;
    longitude?: BaseConfig | boolean;
    async?: AsyncValidatorFn[];
}
